//#######################################################################################//
//Vessel helper structures
struct animcompinfo{
 int msh,id,tp,grp,parent;
 VECTOR3 ref,axshsc;
 float angle;
 double st0,st1;
 MGROUP_TRANSFORM *cmpdef;
 ANIMATIONCOMPONENT_HANDLE cmpt;
};
struct animinfo{
 UINT id;
 DWORD tp,repeat;
 DWORD trigkey;
 int status;
 double spd,proc,init;
 int grpcnt;
 int compcnt;
 unsigned int **grp;
 animcompinfo *comp;
};
struct arminfo{
 double range_low,range_high;
 int seq;
 VECTOR3 tip[3];
 char name[255];
};
struct attachinfo{
 bool ischild,loose;
 double range;
 VECTOR3 pos,dir,rot;
 char name[255],id[255];
};
//#######################################################################################//
//Vessel constants
#define ATTACH_COUNT 2
#define ANIM_COUNT 7
#define ARM_COUNT 7
#define ARM_GRAPPLE_ATTACH 0
#define ARM_GRAPPLE_SEQUENCE 6
//#######################################################################################//
//Vessel class
class Arm:public VESSEL2{
public:
 Arm(OBJHANDLE hObj,int fmodel);
 ~Arm();
 void clbkSetClassCaps(FILEHANDLE cfg);
 void clbkLoadStateEx(FILEHANDLE scn,void *vs);
 void clbkSaveState(FILEHANDLE scn);
 void clbkPostStep(double simt,double simdt,double mjd);
 int  clbkConsumeBufferedKey(DWORD key,bool down,char *kstate);
 int  clbkConsumeDirectKey(char *kstate);
 void toggle_attach(int point);
 
 void define_animations();
 void make_anim(int n,int id,int tp,int repeat,int trigkey,int status,double spd,double proc,double init,int grpcnt,int compcnt);
 void make_anim_comp(int n,int c,int msh,int id,int tp,int grp,int parent,VECTOR3 ref,VECTOR3 axshsc,double angle,double st0,double st1);
 void make_attachment(int n,char *name,char *id,bool loose,bool ischild,double range,VECTOR3 pos,VECTOR3 dir,VECTOR3 rot);
 
 ATTACHMENTHANDLE att_h[ATTACH_COUNT];
 attachinfo att[ATTACH_COUNT];
 MESHHANDLE msh_h[1];
 int msh_idh[1];
 animinfo ani[ANIM_COUNT];
 arminfo arm[ARM_COUNT];

 int arm_on,arm_sel,arm_blank;
 VECTOR3 arm_tip[3];
 int att_on,att_sel,att_blank;
};
//#######################################################################################//
